GOSUB Initialisation
'Le 22 aout 2005. Le principe de Huygens, deux ondelettes. Amplitude seulement.

'*************************** BOUCLE  PRINCIPALE *******************************
DO
    GOSUB Calcul
retour:
    DO: a$ = UCASE$(INKEY$): LOOP WHILE LEN(a$)'        Vider le tampon.
    DO: a$ = UCASE$(INKEY$): LOOP UNTIL LEN(a$)'        Attendre une action.
    IF a$ = CHR$(27) THEN END'                          Sortie.
    IF a$ = "A" THEN  ELSE GOTO retour'                 Image suivante.
    image% = image% + 1: IF image% > images% THEN image% = 1
LOOP

'**************************** CALCUL DE L'ONDE *******************************
Calcul:
LINE (0, 0)-(639, 479), 7, BF'                          Fond gris.
LINE (0, 430)-(300, 479), 0, BF'                        Fenetre de texte.
'LOCATE 28, 2: PRINT "Image No."; image%; "/"; images%
'LOCATE 29, 2: PRINT "Image suivante: appuyez sur  A .";
LOCATE 30, 2: PRINT "Pour quitter, appuyez sur  Echap .";
periode# = image% * 2# * pi# / images%'            Periode selon l'image.

FOR x& = 0 TO largeur%'                            coordonnee x du pixel.
    x# = x& - xOnde#'                              distance, axe horizontal.
    xCarre# = x# * x#'                             carr toujours positif.
    FOR y& = 0 TO hauteur%'                        coordonnee y du pixel.
        amplitudeSinus# = 0#'                      Initialiser.
        amplitudeCosinus# = 0#
        yOnde# = depart#
        FOR ondelette& = 1 TO 2
            y# = y& - yOnde#
            diagonale# = SQR(y# * y# + xCarre#)
            ondes# = diagonale# / lambda#
            entier% = ondes#
            differenceDeMarche# = ondes# - entier%
            phase# = 2# * pi# * differenceDeMarche# - periode#
            IF diagonale# > lambda# / 2# THEN '         normaliser le centre.
                affaiblissement# = lambda# / 2# / diagonale#
            ELSE ' esthetique, ecreter, eviter la division par zero.
                x# = ondes# * 2#' x# en demi-ondes, formule de l'electron:
                affaiblissement# = 2# / (x# ^ 2# + 1#)
            END IF
            amplitudeSinus# = amplitudeSinus# + affaiblissement# * SIN(phase#)
            amplitudeCosinus# = amplitudeCosinus# + affaiblissement# * COS(phase#)
            yOnde# = yOnde# + ecart#
        NEXT ondelette&
        GOSUB affichePixel'                                 vers l'affichage.
    NEXT y&
    IF LEN(INKEY$) THEN EXIT FOR
NEXT x&
RETURN


'************************** AFFICHER LE DIAGRAMME ****************************

affichePixel: '  Ce diagramme n'affiche que l'amplitude et non pas les ondes.
amplitude = (amplitudeSinus# * amplitudeSinus# + amplitudeCosinus# * amplitudeCosinus#)
amplitude = SQR(amplitude)
amplitude = -amplitude'                     inverser les couleurs.
amplitude = 4 * amplitude'                  ajuster le contraste.
amplitude = amplitude + 2'                  ajuster la luminance.
couleur = amplitude * 7.5'                  7.5 * 2 = 15 plus couleur 0.
couleur1 = couleur - .375'                  obtenir 64 tons par diffusion.
couleur2 = couleur - .125
couleur3 = couleur + .125
couleur4 = couleur + .375
'                                           diffusion sur 4 pixels.
IF x& MOD 2 THEN
    IF y& MOD 2 THEN couleur = couleur1 ELSE couleur = couleur4
    ELSE
    IF y& MOD 2 THEN couleur = couleur3 ELSE couleur = couleur2
END IF

couleur = couleur + .3 * RND - .3 * RND'    estomper au hasard.
IF couleur > 15 THEN couleur = 15
IF couleur < 0 THEN couleur = 0
coul% = couleur'                            entier, 16 couleurs.
PSET (x&, y&), coul%'                       afficher les ondelettes.
RETURN

'***************************** INITIALISATION ********************************
Initialisation: '                           variables en double precision (#).
pi# = 4# * ATN(1#)'                         16 chiffres significatifs.
lambda# = 24#'                              longueur d'onde.
images% = 16'                               nombre d'images par periode.
largeur% = 639'                             dimensions de la fenetre.
hauteur% = 300
yCentre% = hauteur% / 2
xOnde# = 50'                                coordonnee fixe x des ondelettes.
rayon# = 2# * lambda#'les ondelettes sont disposees a l'interieur d'un cercle.
ondelettes% = 2'                            nombre d'ondelettes.
ecart# = 2# * rayon# / (ondelettes% - 1)'   ecart entre les ondelettes.
depart# = yCentre% - rayon#'                point de depart des ondelettes.
yCourbe% = hauteur% + 61'                   niveau de la courbe d'amplitude.

'********************* 16 TONS DE GRIS POUR IMAGES GIF ***********************
'       Les couleurs sont inversees pour supporter le texte en noir sur blanc.
SCREEN 12
coul% = 63'                                 64 impossible (* 4 = 256 max 255).
pas% = 4'                                   4 * 16 couleurs : crneau de 64.
FOR j% = 0 TO 15'                           palette a 16 tons de gris.
    PRINT coul%
    OUT &H3C8, j%'                          la couleur correspond a j%.
    OUT &H3C9, coul%'                       valeurs RGB identiques, donc gris.
    OUT &H3C9, coul%
    OUT &H3C9, coul%
    coul% = coul% - pas%'                   dpart  63, donc 63 - 4 = 59.
    NEXT'                                   le noir n'est pas total (= 3).
RETURN

